/*--------------------------------------------------------------
 * $Source: /rcs/vwrcs/components/vwglobal.h,v $
 * Checked in by: $Author: clement $
 * $Date: 1996/07/05 13:59:54 $              $Revision: 1.14 $
 *--------------------------------------------------------------
 *         Copyright(c) 1992, Visual Edge Software Ltd.
 *
 * ALL RIGHTS RESERVED. This notice is intended as a precaution
 * against inadvertent publication, and shall not be deemed to
 * consitute an acknowledgment that publication has occurred
 * nor to imply any waiver of confidentiality. The year included
 * in the notice is the year of the creation of the work.
 *--------------------------------------------------------------
 * DESCRIPTION:
 *            This file contains global definitions & includes.
 * NOTE: Includes are dependent on typedefs so must be last.
 *       THIS FILE IS A C FILE. ALL C++ DECLARATIONS SHOULD
 *       BE PLACED IN vwglobal.hh
 *--------------------------------------------------------------
 */

#ifndef VWGLOBAL_H
#define VWGLOBAL_H

#include <os.h>
#include <visedge.h>
#include <math.h>

#ifdef __cplusplus
extern "C" {
/*
 * Temporary fix. We will change the typedef's below to:
 */
typedef char *  VwString;
typedef VwString *      VwStringTable;

/* these two should no longer be used, VwString and VwStringTable should
 * be used instead.
 */
typedef char*   String;
typedef String* StringTable;

#endif

typedef status_t        VwStatus;
typedef float           VwSingle;
typedef long            VwLong;
#ifndef _OS2
typedef OsWord          VwInt;
#else
typedef int             VwInt;
#endif
typedef OsWord          VwBool;
typedef OsWord          VwEnum;

#ifndef VwTrue
#define VwTrue          -1
#endif

#ifndef VwFalse
#define VwFalse          0
#endif

#define VW_BORDER_WIDTH 2       /* Fixed single border width in pixels */

#define VW_USEABLE_DEF_X        0
#define VW_USEABLE_DEF_Y        0
#define VW_USEABLE_DEF_HEIGHT   492
#define VW_USEABLE_DEF_WIDTH    1142

#define VW_DEF_X        ((-MAXFLOAT) / 10.0)
#define VW_DEF_Y        VW_DEF_X
#define VW_DEF_WIDTH    VW_DEF_X
#define VW_DEF_HEIGHT   VW_DEF_X

#define VW_IS_ARG_SMALLER(x)    ((VW_DEF_X-(MAXFLOAT / 100000))< (x))
#define VW_IS_ARG_BIGGER(x)     ((VW_DEF_X+(MAXFLOAT / 100000))> (x))
#define VW_IS_ARG_DEFAULT(x)    (((x)<0) && VW_IS_ARG_SMALLER(x) && VW_IS_ARG_BIGGER(x))

#define VW_SYS_COLOR(y)         (0x80000000L|y)

#define TwipsPerInch    1440.0F
#define MmPerInch       25.4F

#define VW_RETURN_IN_ASCII 0x0D
#define VW_ESCAPE_IN_ASCII 0x1B

#define VW_USERMODE_RUN		0x00
#define VW_USERMODE_BREAK	0x01
#define VW_USERMODE_DESIGN	0x02

#ifdef __cplusplus
}
#endif

#endif
